#include "compress.h"

Buffer* Compress::CData;

void Compress::Init()
{
	CData = new Buffer();
}

void Compress::Clean()
{
	delete(CData);
}

char* Compress::RLE_encode(char* str, int* size, int block)
{
	int sz = *size;
	int i, j;
	int k = -1;
	int c = 0;

	if (sz == 0)
		sz = (int)strlen(str);
	CData->clear();
	switch(block)
	{
		case 8:
		default:
			for (i = 0; i < sz; i++)
			{
				j = str[i];
				if (k == j)
				{
					c++;
					if (c == 255)
					{
						CData->writeushort(65281);
						c = 0;
					}
				}
				else
				{
					switch(c)
					{
						case 1:
							CData->writebyte(k);
							break;
						case 2:
							CData->writeushort((k<<8)|k);
							break;
						default:
							CData->writebyte(1);
							CData->writebyte(c);
					}
					switch(j)
					{
						case 0:
							CData->writeushort(0);
							break;
						case 1:
							CData->writeushort(256);
							break;
						default:
							CData->writebyte(j);
					}
					k = j;
					c = 0;
				}
			}
			break;
		case 16:
			sz >>= 1;
			for (i = 0; i < sz; i++)
			{
				j = (int)(((unsigned short*)str)[i]);
				if (k == j)
				{
					c++;
					if (c == 255)
					{
						CData->writeint(16711681);
						c = 0;
					}
				}
				else
				{
					if (c == 1)
						CData->writeushort(k);
					else
					{
						CData->writeushort(1);
						CData->writebyte(c);
					}
					switch(j)
					{
						case 0:
							CData->writeushort(0);
							CData->writebyte(0);
							break;
						case 1:
							CData->writeushort(0);
							CData->writebyte(1);
							break;
						default:
							CData->writeushort(j);
					}
					k = j;
					c = 0;
				}
			}
			break;
	}
	(*size) = CData->count;
	return CData->data;
}

char* Compress::RLE_decode(char* str, int* size, int block)
{
	int sz = *size;
	int i, j, k, c;

	if (sz == 0)
		sz = (int)strlen(str);
	CData->clear();
	switch(block)
	{
		case 8:
		default:
			for (i = 0; i < sz; i++)
			{
				j = str[i];
				switch(j)
				{
					case 0:
						j = str[++i];
						CData->writebyte(j);
						break;
					case 1:
						c = str[++i];
						for (k = 0; k < c; k++)
							CData->writebyte(j);
						break;
					default:
						CData->writebyte(j);
				}
			}
		case 16:
			sz >>= 1;
			for (i = 0; i < sz; i++)
			{
				j = (unsigned short)str[i];
				switch(j)
				{
					case 0:
						j = str[(i<<1)+2];
						CData->writeushort(j);
						break;
					case 1:
						c = str[(i<<1)+2];
						for (k = 0; k < c; k++)
							CData->writeushort(j);
						break;
					default:
						CData->writeushort(j);
				}
			}
	}
}