#include "dlist.h"

DList::DList()
{
	size = 8;
	last = 7;
	numfree = 8;
	items = (void**)malloc(8 * sizeof(void*));
	for(int i = 0; i < 8; i++)
		items[i] = NULL;
}

DList::~DList()
{
	free(items);
}

int DList::Add(void* item)
{
	int i;

	if(numfree == 0)
	{
		last += 8;
		size += 8;
		numfree = 7;
		items = (void**)realloc(items, size * sizeof(void*));
		items[last] = item;
		for(i = size - 8; i < last; i++)
			items[i] = NULL;
		return last;
	}
	numfree--;
	for (i = last; i >= 0; i--)
	{
		if(items[i] == NULL)
		{
			items[i] = item;
			return i;
		}
	}
	//if we make it here, something went horribly wrong
	//  but we'll quick fix it
	last += 8;
	size += 8;
	numfree = 7;
	items = (void**)realloc(items, size * sizeof(void*));
	items[last] = item;
	for(i = size - 8; i < last; i++)
		items[i] = NULL;
	return last;
}

void DList::Remove(int index)
{
	if (index < 0 || index > last)
		return;
	if (items[index] == NULL)
		return;
	items[index] = NULL;
	numfree += 1;
}

void* DList::operator[](int index)
{
	if(index < 0 || index > last)
		return NULL;
	return items[index];
}